# -*- coding:Utf-8 -*-

from random import *
from pyGEM import *
from math import *


class Healthy :
	
	#PARAMETRES
	L = 0.3 #Longueur du duodenum (m) 
	v = 7*10**(-3) #Flux de chyme (m/s)	
	alpha = 0.3 #Coeff pour A
	beta = v/L 
	Sp = 2*2.7*10**(-7)*55.6*10**3 
	tetha = 0.72

	def __init__(self,tps,step) :
		self.Time = tps
		self.Time2 = 3*tps
		self.Time3 = 2*tps
		self.Step = step
		self.A = 6*tps*[0]
		self.S = 6*tps*[0]
		self.MaxA = self.Sp*4*tps*step*0.1

	#EXPRESSIONS

	def Chi1(self,t) :
		if t < (self.Time+self.Time2) :
			return 1
		else :
			return 0

	def exprA(self,i) :
		if(self.alpha * self.S[i] - self.tetha*self.A[i] > 0) :
			return self.alpha * self.S[i] - self.tetha*self.A[i]
		else : 
			return 0

	def exprS(self,i) :
		return -self.exprA(i) + (self.Chi1(i)*self.Sp - self.beta * self.S[i])


	def Evolution(self):
		for i in range(0,self.Time+self.Time2+self.Time3-1) :
			self.S[i+1] = self.Step*self.exprS(i) + self.S[i]
			self.A[i+1] = self.Step*self.exprA(i) + self.A[i]


Model = Healthy(420,0.1)

Model.Evolution();
Graph = Graphique(6*Model.Time,Model.Step)

Graph.Curve(1,Model.S,'b','Iron in the middle')
Graph.Curve(1,Model.A,'r','Iron Absorbed')
Graph.Constant(1,Model.MaxA,'g','10% of total iron uptake ')

Graph.Show()